﻿package com.Islands 
{
	import org.flixel.*;

	public class QuoteState extends FlxState
	{
		protected var _timelapsed:Number;
		
		protected var _fading_group:FlxGroup
		
		public function QuoteState() 
		{
			super();
		}
		
		override public function create():void 
		{
			super.create();
			_timelapsed = 0;
			
			SoundLibrary.PlaySound(SoundLibrary.SOUND_MUSIC_INTRO);
			
			bgColor = 0xff000000;
			
			//"Imagine that every man's mind is an island, surrounded by ocean.
			//Each seems isolated,
			//yet in reality all are linked by the bedrock from which they spring.
			//If the oceans were to vanish,
			//that would be the end of the islands."
			
			//Arthur C. Clarke, "Childhood's End"
			
			var col:uint = 0xff999999;
			var bordcol:uint = 0xff0000ff;
			
			var marg:Number = 6;
			
			var newheight:Number = 15;
			
			_fading_group = new FlxGroup();
			
			var txt:FlxText = new FlxText(marg, newheight, FlxG.width - 2*marg, "\"Imagine that every man's mind is an island, surrounded by ocean.");
			txt.setFormat(null, 16, col, "left", bordcol);
			txt.alpha = 0;
			_fading_group.add(txt);
			
			newheight = txt.y + txt.height;
			txt = new FlxText(marg, newheight, FlxG.width - 2*marg, "Each seems isolated, yet in reality");
			txt.setFormat(null, 16, col, "left", bordcol);
			txt.alpha = 0;
			_fading_group.add(txt);
			
			newheight = txt.y + txt.height;
			txt = new FlxText(marg, newheight, FlxG.width - 2*marg, "all are linked by the bedrock from which they spring.");
			txt.setFormat(null, 16, col, "left", bordcol);
			txt.alpha = 0;
			_fading_group.add(txt);
			
			newheight = txt.y + txt.height;
			txt = new FlxText(marg, newheight, FlxG.width - 2*marg, "If the oceans were to vanish,");
			txt.setFormat(null, 16, col, "left", bordcol);
			txt.alpha = 0;
			_fading_group.add(txt);
			
			newheight = txt.y + txt.height;
			txt = new FlxText(marg, newheight, FlxG.width - 2*marg, "that would be the end of the islands.\"");
			txt.setFormat(null, 16, col, "left", bordcol);
			txt.alpha = 0;
			_fading_group.add(txt);
			
			newheight = txt.y + txt.height;
			txt = new FlxText(marg, newheight, FlxG.width - 2*marg, "Arthur C. Clarke, \"Childhood's End\"");
			txt.setFormat(null, 8, col, "right", bordcol);
			txt.alpha = 0;
			_fading_group.add(txt);
			
			this.add(_fading_group);
			
			txt = new FlxText(0, 0, FlxG.width, "press x to skip");
			txt.setFormat(null, 8, 0x00aa4444, "center");
			this.add(txt);
		}
		
		protected function OnFadeFinish():void
		{
			FlxG.state = new GameState();
		}
		
		override public function update():void 
		{
			super.update();
			SoundLibrary.Update();
			
			_timelapsed += FlxG.elapsed;
			
			var i:uint = 0;
			
			const time_before_start:Number = 1;
			const fade_in_rate:Number = 0.35;
			
			var done:Boolean = true;
			
			for each(var txt:FlxText in _fading_group.members)
			{
				var thealpha:Number = fade_in_rate * _timelapsed - i * time_before_start;
				done = (thealpha > 2.5);
				txt.alpha = Math.min(thealpha, 1.0);
				i++;
			}
			
			if (done || FlxG.keys.justPressed("X"))
			{
				FlxG.fade.start(0xff000000, 1, OnFadeFinish);
				SoundLibrary.StopSound(SoundLibrary.SOUND_MUSIC_INTRO, 2);
			}
		}
	}
}