﻿package com.Islands 
{
	import org.flixel.*;
	
	public class WaterSwitch extends FlxSprite
	{
		[Embed(source = '../../gfx/Switch.png')] private var ImgSwitch:Class;
		
		protected var switch_active:Boolean;
		
		public function WaterSwitch(X:Number, Y:Number) 
		{
			super(X, Y);
			loadGraphic(ImgSwitch, true, false, Islands.TILE_SIZE);
			addAnimation("on", [0], 1, true);
			addAnimation("off", [1], 1, true);
			play("on", true);
			switch_active = true;
			fixed = true;
		}
		
		override public function hitLeft(Contact:FlxObject, Velocity:Number):void 
		{
			super.hitLeft(Contact, Velocity);
			
			if (Contact is Player)
				kill();
		}
		
		override public function hitBottom(Contact:FlxObject, Velocity:Number):void 
		{
			super.hitBottom(Contact, Velocity);
			if (Contact is Player)
				kill();
		}
		
		override public function hitRight(Contact:FlxObject, Velocity:Number):void 
		{
			super.hitRight(Contact, Velocity);
			if (Contact is Player)
				kill();
		}
		
		override public function hitTop(Contact:FlxObject, Velocity:Number):void 
		{
			super.hitTop(Contact, Velocity);
			if (Contact is Player)
				kill();
		}
		
		override public function kill():void 
		{
			if (switch_active)
			{
				//super.kill();
				FlxG.quake.start(0.07, 2);
				(FlxG.state as GameState).WaterRecede();
				this.play("off");
				switch_active = false;
				SoundLibrary.PlaySound(SoundLibrary.SOUND_WATER_RECEDE);
			}
		}
		
	}

}