﻿package util 
{
	import org.flixel.*;
	
	public class ExtraFlxTileMap extends FlxTilemap
	{
		public function ExtraFlxTileMap() 
		{
			super();
		}

		/**
		 * Returns overlapping tile
		 * 
		 * @param	Core		The <code>FlxCore</code> you want to check against.
		 */
		public function get_overlap_tile(Core:FlxObject):FlxObject
		{
			var c:uint;
			var d:uint;
			var i:uint;
			var dd:uint;
			var blocks:Array = new Array();
			
			//First make a list of all the blocks we'll use for collision
			var ix:uint = Math.floor((Core.x - x)/_tileWidth);
			var iy:uint = Math.floor((Core.y - y)/_tileHeight);
			var iw:uint = Math.ceil(Core.width/_tileWidth)+1;
			var ih:uint = Math.ceil(Core.height/_tileHeight)+1;
			for(var r:uint = 0; r < ih; r++)
			{
				if(r >= heightInTiles) break;
				d = (iy+r)*widthInTiles+ix;
				for(c = 0; c < iw; c++)
				{
					if(c >= widthInTiles) break;
					dd = _data[d+c] as uint;
					if(dd >= collideIndex)
						blocks.push({x:x+(ix+c)*_tileWidth,y:y+(iy+r)*_tileHeight,data:dd});
				}
			}
			
			//Then check for overlaps
			var bl:uint = blocks.length;
			var hx:Boolean = false;
			for(i = 0; i < bl; i++)
			{
				_block.x = blocks[i].x;
				_block.y = blocks[i].y;
				if(_block.overlaps(Core))
					return _block;
			}
			return null;
		}
				
	}

}